//
// Copyright (c) 2012-2016 Krzysztof Jusiak (krzysztof at jusiak dot net)
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//
#include <di/registry.hpp>
#include <di/injector.hpp>
#include <di/constructor.hpp>

// clang-format off
struct X00 { DI_CONSTRUCTOR(X00, ()) { } };
struct X01 { DI_CONSTRUCTOR(X01, (X00)) { } };
struct X02 { DI_CONSTRUCTOR(X02, (X00, X01)) { } };
struct X03 { DI_CONSTRUCTOR(X03, (X00, X01, X02)) { } };
struct X04 { DI_CONSTRUCTOR(X04, (X00, X01, X02, X03)) { } };
struct X05 { DI_CONSTRUCTOR(X05, (X00, X01, X02, X03, X04)) { } };
struct X06 { DI_CONSTRUCTOR(X06, (X00, X01, X02, X03, X04, X05)) { } };
struct X07 { DI_CONSTRUCTOR(X07, (X00, X01, X02, X03, X04, X05, X06)) { } };
struct X08 { DI_CONSTRUCTOR(X08, (X00, X01, X02, X03, X04, X05, X06, X07)) { } };
struct X09 { DI_CONSTRUCTOR(X09, (X00, X01, X02, X03, X04, X05, X06, X07, X08)) { } };
struct X10 { DI_CONSTRUCTOR(X10, (X00, X01, X02, X03, X04, X05, X06, X07, X08, X09)) { } };
struct X11 { DI_CONSTRUCTOR(X11, (X01, X02, X03, X04, X05, X06, X07, X08, X09, X10)) { } };
struct X12 { DI_CONSTRUCTOR(X12, (X02, X03, X04, X05, X06, X07, X08, X09, X10, X11)) { } };
struct X13 { DI_CONSTRUCTOR(X13, (X03, X04, X05, X06, X07, X08, X09, X10, X11, X12)) { } };
struct X14 { DI_CONSTRUCTOR(X14, (X04, X05, X06, X07, X08, X09, X10, X11, X12, X13)) { } };
struct X15 { DI_CONSTRUCTOR(X15, (X05, X06, X07, X08, X09, X10, X11, X12, X13, X14)) { } };
struct X16 { DI_CONSTRUCTOR(X16, (X06, X07, X08, X09, X10, X11, X12, X13, X14, X15)) { } };
struct X17 { DI_CONSTRUCTOR(X17, (X07, X08, X09, X10, X11, X12, X13, X14, X15, X16)) { } };
struct X18 { DI_CONSTRUCTOR(X18, (X08, X09, X10, X11, X12, X13, X14, X15, X16, X17)) { } };
struct X19 { DI_CONSTRUCTOR(X19, (X09, X10, X11, X12, X13, X14, X15, X16, X17, X18)) { } };
struct X20 { DI_CONSTRUCTOR(X20, (X10, X11, X12, X13, X14, X15, X16, X17, X18, X19)) { } };
struct X21 { DI_CONSTRUCTOR(X21, (X11, X12, X13, X14, X15, X16, X17, X18, X19, X20)) { } };
struct X22 { DI_CONSTRUCTOR(X22, (X12, X13, X14, X15, X16, X17, X18, X19, X20, X21)) { } };
struct X23 { DI_CONSTRUCTOR(X23, (X13, X14, X15, X16, X17, X18, X19, X20, X21, X22)) { } };
struct X24 { DI_CONSTRUCTOR(X24, (X14, X15, X16, X17, X18, X19, X20, X21, X22, X23)) { } };
struct X25 { DI_CONSTRUCTOR(X25, (X15, X16, X17, X18, X19, X20, X21, X22, X23, X24)) { } };
struct X26 { DI_CONSTRUCTOR(X26, (X16, X17, X18, X19, X20, X21, X22, X23, X24, X25)) { } };
struct X27 { DI_CONSTRUCTOR(X27, (X17, X18, X19, X20, X21, X22, X23, X24, X25, X26)) { } };
struct X28 { DI_CONSTRUCTOR(X28, (X18, X19, X20, X21, X22, X23, X24, X25, X26, X27)) { } };
struct X29 { DI_CONSTRUCTOR(X29, (X19, X20, X21, X22, X23, X24, X25, X26, X27, X28)) { } };
struct X30 { DI_CONSTRUCTOR(X30, (X20, X21, X22, X23, X24, X25, X26, X27, X28, X29)) { } };
struct X31 { DI_CONSTRUCTOR(X31, (X21, X22, X23, X24, X25, X26, X27, X28, X29, X30)) { } };
struct X32 { DI_CONSTRUCTOR(X32, (X22, X23, X24, X25, X26, X27, X28, X29, X30, X31)) { } };
struct X33 { DI_CONSTRUCTOR(X33, (X23, X24, X25, X26, X27, X28, X29, X30, X31, X32)) { } };
struct X34 { DI_CONSTRUCTOR(X34, (X24, X25, X26, X27, X28, X29, X30, X31, X32, X33)) { } };
struct X35 { DI_CONSTRUCTOR(X35, (X25, X26, X27, X28, X29, X30, X31, X32, X33, X34)) { } };
struct X36 { DI_CONSTRUCTOR(X36, (X26, X27, X28, X29, X30, X31, X32, X33, X34, X35)) { } };
struct X37 { DI_CONSTRUCTOR(X37, (X27, X28, X29, X30, X31, X32, X33, X34, X35, X36)) { } };
struct X38 { DI_CONSTRUCTOR(X38, (X28, X29, X30, X31, X32, X33, X34, X35, X36, X37)) { } };
struct X39 { DI_CONSTRUCTOR(X39, (X29, X30, X31, X32, X33, X34, X35, X36, X37, X38)) { } };
struct X40 { DI_CONSTRUCTOR(X40, (X30, X31, X32, X33, X34, X35, X36, X37, X38, X39)) { } };
struct X41 { DI_CONSTRUCTOR(X41, (X31, X32, X33, X34, X35, X36, X37, X38, X39, X40)) { } };
struct X42 { DI_CONSTRUCTOR(X42, (X32, X33, X34, X35, X36, X37, X38, X39, X40, X41)) { } };
struct X43 { DI_CONSTRUCTOR(X43, (X33, X34, X35, X36, X37, X38, X39, X40, X41, X42)) { } };
struct X44 { DI_CONSTRUCTOR(X44, (X34, X35, X36, X37, X38, X39, X40, X41, X42, X43)) { } };
struct X45 { DI_CONSTRUCTOR(X45, (X35, X36, X37, X38, X39, X40, X41, X42, X43, X44)) { } };
struct X46 { DI_CONSTRUCTOR(X46, (X36, X37, X38, X39, X40, X41, X42, X43, X44, X45)) { } };
struct X47 { DI_CONSTRUCTOR(X47, (X37, X38, X39, X40, X41, X42, X43, X44, X45, X46)) { } };
struct X48 { DI_CONSTRUCTOR(X48, (X38, X39, X40, X41, X42, X43, X44, X45, X46, X47)) { } };
struct X49 { DI_CONSTRUCTOR(X49, (X39, X40, X41, X42, X43, X44, X45, X46, X47, X48)) { } };
struct X50 { DI_CONSTRUCTOR(X50, (X40, X41, X42, X43, X44, X45, X46, X47, X48, X49)) { } };
struct X51 { DI_CONSTRUCTOR(X51, (X41, X42, X43, X44, X45, X46, X47, X48, X49, X50)) { } };
struct X52 { DI_CONSTRUCTOR(X52, (X42, X43, X44, X45, X46, X47, X48, X49, X50, X51)) { } };
struct X53 { DI_CONSTRUCTOR(X53, (X43, X44, X45, X46, X47, X48, X49, X50, X51, X52)) { } };
struct X54 { DI_CONSTRUCTOR(X54, (X44, X45, X46, X47, X48, X49, X50, X51, X52, X53)) { } };
struct X55 { DI_CONSTRUCTOR(X55, (X45, X46, X47, X48, X49, X50, X51, X52, X53, X54)) { } };
struct X56 { DI_CONSTRUCTOR(X56, (X46, X47, X48, X49, X50, X51, X52, X53, X54, X55)) { } };
struct X57 { DI_CONSTRUCTOR(X57, (X47, X48, X49, X50, X51, X52, X53, X54, X55, X56)) { } };
struct X58 { DI_CONSTRUCTOR(X58, (X48, X49, X50, X51, X52, X53, X54, X55, X56, X57)) { } };
struct X59 { DI_CONSTRUCTOR(X59, (X49, X50, X51, X52, X53, X54, X55, X56, X57, X58)) { } };
struct X60 { DI_CONSTRUCTOR(X60, (X50, X51, X52, X53, X54, X55, X56, X57, X58, X59)) { } };
struct X61 { DI_CONSTRUCTOR(X61, (X51, X52, X53, X54, X55, X56, X57, X58, X59, X60)) { } };
struct X62 { DI_CONSTRUCTOR(X62, (X52, X53, X54, X55, X56, X57, X58, X59, X60, X61)) { } };
struct X63 { DI_CONSTRUCTOR(X63, (X53, X54, X55, X56, X57, X58, X59, X60, X61, X62)) { } };
struct X64 { DI_CONSTRUCTOR(X64, (X54, X55, X56, X57, X58, X59, X60, X61, X62, X63)) { } };
struct X65 { DI_CONSTRUCTOR(X65, (X55, X56, X57, X58, X59, X60, X61, X62, X63, X64)) { } };
struct X66 { DI_CONSTRUCTOR(X66, (X56, X57, X58, X59, X60, X61, X62, X63, X64, X65)) { } };
struct X67 { DI_CONSTRUCTOR(X67, (X57, X58, X59, X60, X61, X62, X63, X64, X65, X66)) { } };
struct X68 { DI_CONSTRUCTOR(X68, (X58, X59, X60, X61, X62, X63, X64, X65, X66, X67)) { } };
struct X69 { DI_CONSTRUCTOR(X69, (X59, X60, X61, X62, X63, X64, X65, X66, X67, X68)) { } };
struct X70 { DI_CONSTRUCTOR(X70, (X60, X61, X62, X63, X64, X65, X66, X67, X68, X69)) { } };
struct X71 { DI_CONSTRUCTOR(X71, (X61, X62, X63, X64, X65, X66, X67, X68, X69, X70)) { } };
struct X72 { DI_CONSTRUCTOR(X72, (X62, X63, X64, X65, X66, X67, X68, X69, X70, X71)) { } };
struct X73 { DI_CONSTRUCTOR(X73, (X63, X64, X65, X66, X67, X68, X69, X70, X71, X72)) { } };
struct X74 { DI_CONSTRUCTOR(X74, (X64, X65, X66, X67, X68, X69, X70, X71, X72, X73)) { } };
struct X75 { DI_CONSTRUCTOR(X75, (X65, X66, X67, X68, X69, X70, X71, X72, X73, X74)) { } };
struct X76 { DI_CONSTRUCTOR(X76, (X66, X67, X68, X69, X70, X71, X72, X73, X74, X75)) { } };
struct X77 { DI_CONSTRUCTOR(X77, (X67, X68, X69, X70, X71, X72, X73, X74, X75, X76)) { } };
struct X78 { DI_CONSTRUCTOR(X78, (X68, X69, X70, X71, X72, X73, X74, X75, X76, X77)) { } };
struct X79 { DI_CONSTRUCTOR(X79, (X69, X70, X71, X72, X73, X74, X75, X76, X77, X78)) { } };
struct X80 { DI_CONSTRUCTOR(X80, (X70, X71, X72, X73, X74, X75, X76, X77, X78, X79)) { } };
struct X81 { DI_CONSTRUCTOR(X81, (X71, X72, X73, X74, X75, X76, X77, X78, X79, X80)) { } };
struct X82 { DI_CONSTRUCTOR(X82, (X72, X73, X74, X75, X76, X77, X78, X79, X80, X81)) { } };
struct X83 { DI_CONSTRUCTOR(X83, (X73, X74, X75, X76, X77, X78, X79, X80, X81, X82)) { } };
struct X84 { DI_CONSTRUCTOR(X84, (X74, X75, X76, X77, X78, X79, X80, X81, X82, X83)) { } };
struct X85 { DI_CONSTRUCTOR(X85, (X75, X76, X77, X78, X79, X80, X81, X82, X83, X84)) { } };
struct X86 { DI_CONSTRUCTOR(X86, (X76, X77, X78, X79, X80, X81, X82, X83, X84, X85)) { } };
struct X87 { DI_CONSTRUCTOR(X87, (X77, X78, X79, X80, X81, X82, X83, X84, X85, X86)) { } };
struct X88 { DI_CONSTRUCTOR(X88, (X78, X79, X80, X81, X82, X83, X84, X85, X86, X87)) { } };
struct X89 { DI_CONSTRUCTOR(X89, (X79, X80, X81, X82, X83, X84, X85, X86, X87, X88)) { } };
struct X90 { DI_CONSTRUCTOR(X90, (X80, X81, X82, X83, X84, X85, X86, X87, X88, X89)) { } };
struct X91 { DI_CONSTRUCTOR(X91, (X81, X82, X83, X84, X85, X86, X87, X88, X89, X90)) { } };
struct X92 { DI_CONSTRUCTOR(X92, (X82, X83, X84, X85, X86, X87, X88, X89, X90, X91)) { } };
struct X93 { DI_CONSTRUCTOR(X93, (X83, X84, X85, X86, X87, X88, X89, X90, X91, X92)) { } };
struct X94 { DI_CONSTRUCTOR(X94, (X84, X85, X86, X87, X88, X89, X90, X91, X92, X93)) { } };
struct X95 { DI_CONSTRUCTOR(X95, (X85, X86, X87, X88, X89, X90, X91, X92, X93, X94)) { } };
struct X96 { DI_CONSTRUCTOR(X96, (X86, X87, X88, X89, X90, X91, X92, X93, X94, X95)) { } };
struct X97 { DI_CONSTRUCTOR(X97, (X87, X88, X89, X90, X91, X92, X93, X94, X95, X96)) { } };
struct X98 { DI_CONSTRUCTOR(X98, (X88, X89, X90, X91, X92, X93, X94, X95, X96, X97)) { } };
struct X99 { DI_CONSTRUCTOR(X99, (X89, X90, X91, X92, X93, X94, X95, X96, X97, X98)) { } };
struct Simple { DI_CONSTRUCTOR(Simple, (X99, X89, X79, X69, X59, X49, X39, X29, X19, X09)) { } };
// clang-format on

void module(di::registry&) {}

int main() {
  di::injector injector;
  injector.install(module);
  injector.construct<Simple>();
}
